513.找树左下角的值
题目链接:513.找树左下角的值
文章讲解:代码随想录|513.找树左下角的值
视频讲解:怎么找二叉树的左下角? 递归中又带回溯了,怎么办?| LeetCode:513.找二叉树左下角的值
思路
递归法
遍历每个节点,比较每个叶子节点的深度,找到深度最大的叶子节点。又因为不管是什么顺序的遍历,左节点都比右节点先遍历到,所以记录下最深的第一个节点值即可
迭代法
层序遍历,用队列实现,记录每一层的第一个元素,最后存着的就是最后一层的最左边元素
代码
递归法
class Solution {
public:
int maxDepth = INT_MIN;
int result;
void traversal(TreeNode* root, int depth) {
if (root->left == NULL && root->right == NULL) {
if (depth > maxDepth) {
maxDepth = depth;
result = root->val;
}
return;
}
if (root->left) {
depth++;
traversal(root->left, depth);
depth--; // 回溯
}
if (root->right) {
depth++;
traversal(root->right, depth);
depth--; // 回溯
}
return;
}
int findBottomLeftValue(TreeNode* root) {
traversal(root, 0);
return result;
}
};
迭代法
class Solution {
public:
int findBottomLeftValue(TreeNode* root) {
int result = 0;
queue<TreeNode*> que;
if(root)que.push(root);
while(!que.empty()){
int size = que.size();
for(int i = 0; i < size; i++){
if(i == 0) result = que.front()->val;
TreeNode* node = que.front();
que.pop();
if(node->left) que.push(node->left);
if(node->right) que.push(node->right);
}
}
return result;
}
};
112. 路径总和
题目链接:112. 路径总和
文章讲解:代码随想录|112. 路径总和
视频讲解:112. 路径总和
思路
使用深度优先遍历
代码
class Solution {
public:
bool traversal(TreeNode* cur, int targetSum, int sum){
if(cur->left == nullptr && cur->right == nullptr && sum == targetSum) return true;
if(cur->left == nullptr && cur->right == nullptr && sum != targetSum) return false;
if(cur->left){
sum += cur->left->val;
if(traversal(cur->left, targetSum, sum)) return true;
sum -= cur->left->val;
}
if(cur->right){
sum += cur->right->val;
if(traversal(cur->right, targetSum, sum)) return true;
sum -= cur->right->val;
}
return false;
}
bool hasPathSum(TreeNode* root, int targetSum) {
if(root == nullptr) return false;
return traversal(root, targetSum, root->val); // sum是加上cur之后的sum,所以这边是root->val
}
};
113. 路径总和ii
题目链接:113. 路径总和ii
文章讲解:代码随想录|113. 路径总和ii
思路
本题是需要访问所有节点,所以递归函数的返回值不能是bool,如果是bool的话会只返回一条路径:
当返回值是bool时:if(traversal(cur->right, targetSum, sum)) return true;如果递归函数返回了第一个true,就会一路返回true到根节点然后结束递归。
当没有返回值时:traversal(cur->left, sum, targetSum);就是遍历整棵树,且不需要处理递归返回值
代码
class Solution {
vector<vector<int>> result;
vector<int> path;
void traversal(TreeNode* cur, int sum, int targetSum){
if(!cur->left && !cur->right && sum == targetSum){
result.push_back(path);
return;
}
if(!cur->left && !cur->right) return;
if(cur->left){
sum += cur->left->val;
path.push_back(cur->left->val);
traversal(cur->left, sum, targetSum);
sum -= cur->left->val;
path.pop_back();
}
if(cur->right){
sum += cur->right->val;
path.push_back(cur->right->val);
traversal(cur->right, sum, targetSum);
sum -= cur->right->val;
path.pop_back();
}
return;
}
public:
vector<vector<int>> pathSum(TreeNode* root, int targetSum) {
if(!root) return result;
path.push_back(root->val);
traversal(root, root->val, targetSum);
return result;
}
};
106.从中序与后序遍历序列构造二叉树
题目链接:106.从中序与后序遍历序列构造二叉树
文章讲解:代码随想录|106.从中序与后序遍历序列构造二叉树
视频讲解:106.从中序与后序遍历序列构造二叉树
思路
输入:inorder = [9,3,15,20,7], postorder = [9,15,7,20,3]
输出:[3,9,20,null,null,15,7]
不论那种遍历方式,都有个共同特点:是一个子树的元素是在一块的
后序遍历的特点是每个子树的根节点是这块元素的最后一个
中序遍历的特点是每个子树的根节点在该子树的两个子树之间
因此我们可以先通过后序遍历找到某个子树的根节点,然后用这个根节点在中序遍历中区分该子树的两个子树,然后递归找这两个子树的子树……
第一步:如果数组大小为零的话,说明是空节点了。
第二步:如果不为空,那么取后序数组最后一个元素作为节点元素。
第三步:找到后序数组最后一个元素在中序数组的位置,作为切割点
第四步:切割中序数组,切成中序左数组和中序右数组 (顺序别搞反了,一定是先切中序数组)
第五步:切割后序数组,切成后序左数组和后序右数组
第六步:递归处理左区间和右区间
代码
class Solution {
private:
TreeNode* traversal (vector<int>& inorder, vector<int>& postorder) {
if (postorder.size() == 0) return NULL;
// 后序遍历数组最后一个元素,就是当前的中间节点
int rootValue = postorder[postorder.size() - 1];
TreeNode* root = new TreeNode(rootValue);
// 叶子节点
if (postorder.size() == 1) return root;
// 找到中序遍历的切割点
int delimiterIndex;
for (delimiterIndex = 0; delimiterIndex < inorder.size(); delimiterIndex++) {
if (inorder[delimiterIndex] == rootValue) break;
}
// 切割中序数组
// 左闭右开区间:[0, delimiterIndex)
vector<int> leftInorder(inorder.begin(), inorder.begin() + delimiterIndex);
// [delimiterIndex + 1, end)
vector<int> rightInorder(inorder.begin() + delimiterIndex + 1, inorder.end() );
// postorder 舍弃末尾元素
postorder.resize(postorder.size() - 1);
// 切割后序数组
// 依然左闭右开,注意这里使用了左中序数组大小作为切割点
// [0, leftInorder.size)
vector<int> leftPostorder(postorder.begin(), postorder.begin() + leftInorder.size());
// [leftInorder.size(), end)
vector<int> rightPostorder(postorder.begin() + leftInorder.size(), postorder.end());
root->left = traversal(leftInorder, leftPostorder);
root->right = traversal(rightInorder, rightPostorder);
return root;
}
public:
TreeNode* buildTree(vector<int>& inorder, vector<int>& postorder) {
if (inorder.size() == 0 || postorder.size() == 0) return NULL;
return traversal(inorder, postorder);
}
};